<?php

/**
 * Fragebogen
 *
 * @version 2004-06-29
 * @author Thiemo Mttig (http://maettig.com/)
 */

function ausgabe($seiteninhalt, $zurueck = 0)
{
  global $fragebogen;

  header('Content-Type: text/html; charset=ISO-8859-1');
  echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
  echo "<html lang=\"de\">\n<head>\n";
  echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\">\n";
  echo "<title>Auswertung</title>\n";
  echo "<meta name=\"author\" content=\"Thiemo Mttig\">\n";
  echo "<meta name=\"robots\" content=\"noindex,nofollow\">\n";
  echo "<meta http-equiv=\"expires\" content=\"0\">\n";
  echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
  echo "<style type=\"text/css\"><!--\n";
  echo "p,th,td{font-size:11pt;}\n";
  echo "h3{font-size:15pt;}\n";
  echo "th{vertical-align:top;text-align:left;}\n";
  echo "td{vertical-align:top;}\n";
  echo "hr{height:1px;color:#666666;}\n";
  echo "--></style>\n";
  echo "</head>\n";
  echo "<body bgcolor=\"#D0D0E0\">\n\n";
  echo "<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"740\">\n<tr>\n<td>\n\n";
  echo "<h3 align=\"center\">Auswertung";
  if ($fragebogen) echo " des Fragebogens $fragebogen";
  echo "</h3>\n\n";

  echo $seiteninhalt;

  if ($zurueck < 0)
    echo "<p><form><input type=button value=\"Zurck\" onclick=\"history.back()\"></form>";

  echo "\n\n</td>\n</tr>\n</table>\n\n";
  echo "</body>\n</html>";
  die();
}

//----------------------------------------------------------------------------

$fragebogen = $_REQUEST['fragebogen'];
if (! $fragebogen) $fragebogen = getenv('QUERY_STRING');

if (! $fragebogen)
  ausgabe("Es wurde kein zu bearbeitender Fragebogen angegeben.", -1);

if (! file_exists($fragebogen . '.csv'))
  ausgabe("Zum Fragebogen <b>$fragebogen</b> sind noch keine Antworten vorhanden.", -1);

$f = implode('', file($fragebogen . '.txt'));

preg_match('/NULL\s*\(\s*(\[.*?\])?(.*?)\)/is', $f, $m);
$null = trim($m[2]);

//----------------------------------------------------------------------------

if ($_REQUEST['trennzeichen'])
{
  if ($_REQUEST['trennzeichen'] == "\t")
  {
    header("Content-Type: text/plain");
    header("Content-Disposition: attachment; filename=\"$fragebogen.txt\"");
  }
  else
  {
    header("Content-Type: text/comma-separated-values");
    header("Content-Disposition: attachment; filename=\"$fragebogen.csv\"");
  }
  $fp = fopen($fragebogen . '.csv', 'r');
  while ($alt = fgetcsv($fp, 100000))
  {
    $res = '';
    foreach ($alt as $val)
    {
      if ($res != '') $res .= $_REQUEST['trennzeichen'];
      $res .= $val;
    }
    echo $res, "\r\n";
  }
  die();
}

//----------------------------------------------------------------------------

$fp = fopen($fragebogen . '.csv', 'r');
$titel = fgetcsv($fp, 100000);
$zeit_von = time();

while ($alt = fgetcsv($fp, 100000))
{
  $anzahl++;
  $zeit = strtotime($alt[count($alt) - 2]);
  if ($zeit < $zeit_von) $zeit_von = $zeit;
  if ($zeit > $zeit_bis) $zeit_bis = $zeit;

  foreach ($alt as $key => $val)
  {
    if ($titel[$key] == 'zeit' || $titel[$key] == 'ip') continue;

    if (! isset($stat[$key])) $stat[$key] = array();
    if ($val == '' || $val == '-' || $val == $null) continue;

    $stat[$key][$val]++;
    $all[$key]++;

    $val2 = preg_replace('/.*?(-?\d+(\.\d+)?).*/', '\1', strtr($val, ',', '.'));
    if (is_numeric($val2))
    {
      $sum[$key] += $val2;
      $count[$key]++;
    }
  }
}

//----------------------------------------------------------------------------

$form = "<p>Fragebgen herunterladen als: ";
$form .= "<a href=\"$PHP_SELF?trennzeichen=,&fragebogen=$fragebogen\"><b>CSV</b> (Komma getrennt)</a>,\n";
$form .= "<a href=\"$PHP_SELF?trennzeichen=%3B&fragebogen=$fragebogen\"><b>CSV</b> (Semikolon getrennt)</a>,\n";
$form .= "<a href=\"$PHP_SELF?trennzeichen=%09&fragebogen=$fragebogen\"><b>Text</b> (Tabs getrennt)</a><br>\n";
$form .= "Abgeschickte Fragebgen insgesamt: <b>$anzahl</b><br>\n";$form .= "Zeitraum: <b>" . date('d.m.Y', $zeit_von) . "</b> bis <b>" . date('d.m.Y', $zeit_bis) . "</b></p>\n\n";$form .= "<table border=0 cellpadding=3 cellspacing=0 width=\"100%\">\n";
$form .= "<tr><td colspan=3><hr></td></tr>\n";

//----------------------------------------------------------------------------

foreach ($stat as $key => $val)
{
  $form .= '<tr><th>' . $titel[$key] . '</th><td>';
  $vorn = '';
  $hinten = '';

  if ($count[$key] > 1)
  {
    $vorn .= "arithmetisches&nbsp;Mittel<br>\n";
    $hinten .= number_format($sum[$key] / $count[$key], 2, ',', '.') . "<br>\n";
  }

  arsort($stat[$key]);
  if (current($stat[$key]) > 1)
  {
    reset($stat[$key]);
    $sonstig = 0;
    foreach ($stat[$key] as $a => $b)
    {
      if ($b < 2)
        $sonstig++;
      else
      {
        $vorn .= round($b * 100 / $all[$key]) . "% ($b&nbsp;mal)<br>\n";
        $hinten .= "$a<br>\n";
      }
    }
    if ($sonstig > 1) $vorn .= "$sonstig sonstige Antworten";
  }
  else
  {
    reset($stat[$key]);
    $i = 0;
    foreach ($stat[$key] as $a => $b)
    {
      if (++$i > 10) break;
      $hinten .= htmlspecialchars($a) . "<br>\n";
    }
    if ($i > 10) $vorn .= 'Auswahl von Antworten';
    elseif ($i) $vorn .= 'alle Antworten';
    else $vorn .= 'keine Antworten';
  }

  $form .= "$vorn</td><td>$hinten</td></tr>\n";
  $form .= "<tr><td colspan=3><hr></td></tr>\n";
}

//----------------------------------------------------------------------------

$form .= "</table>\n";
ausgabe($form);

?>