<?php

/**
 * Fragebogen
 *
 * @version 2005-05-24
 * @author Thiemo Mttig (http://maettig.com/)
 */

function ausgabe($seiteninhalt, $zurueck = 0)
{
  global $_POST, $ueberschrift;

  if (! $ueberschrift) $ueberschrift = "Fragebogen";

  header('Content-Type: text/html; charset=ISO-8859-1');
  echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
  echo "<html>\n<head>\n<title>$ueberschrift</title>\n";
  echo "<meta name=\"author\" content=\"Thiemo Mttig\">\n";
  echo "<meta name=\"robots\" content=\"noindex,nofollow\">\n";
  echo "<meta http-equiv=\"expires\" content=\"86400\">\n";
  echo "<style><!--\n";
  echo "p,th,td{font-size:10pt; font-family: Arial, Helvetica, sans-serif;}\n";
  echo "h3{font-size:15pt; color:#003399;}\n";
  echo "th{vertical-align:top;text-align:left;}\n";
  echo "td{vertical-align:top;}\n";
  echo "hr{height:1px;color:#003399;}\n";
  echo "//--></style>\n";
  echo "</head>\n";
  echo "<body bgcolor=\"white\">\n\n";
  echo "<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"740\">\n<tr>\n<td>\n\n";
  echo "<h3 align=\"center\">$ueberschrift</h3>\n\n";

  echo $seiteninhalt;

  if ($_POST['multiple_choize_erzwingen'] == '0')
    echo "<p><form><input type=button value=\"Zurck zur Homepage\" onclick=\"history.go(-3)\"></form>";
  elseif ($zurueck < -1)
    echo "<p><form><input type=button value=\"Zurck zur Homepage\" onclick=\"history.go($zurueck)\"></form>";
  elseif ($zurueck < 0)
    echo "<p><form><input type=button value=\"Zurck\" onclick=\"history.back()\"></form>";

  echo "\n\n</td>\n</tr>\n</table>\n\n";
  echo "</body>\n</html>";
  die();
}

//----------------------------------------------------------------------------

$fragebogen = $_REQUEST['fragebogen'];
if (! $fragebogen) $fragebogen = getenv('QUERY_STRING');

if (! $fragebogen)
  ausgabe("Es wurde kein zu bearbeitender Fragebogen angegeben.", -1);

if (! file_exists($fragebogen . '.txt'))
  ausgabe("Der Fragebogen <b>$fragebogen</b> konnte nicht gefunden werden.", -1);

//if ($HTTP_COOKIE_VARS['teilnahme'])
//  ausgabe("Von diesem Rechner aus wurde der Fragebogen schon einmal abgeschickt.", -1);

if ($_POST['submit'] && getenv('HTTP_REFERER') != '' &&
    ! strstr(getenv('HTTP_REFERER'), preg_replace('/\/?index\..*/i', '', getenv('SCRIPT_NAME'))))
  ausgabe("Diese Anfrage ist unzulssig.", -2);

//----------------------------------------------------------------------------

$f = implode('', file($fragebogen . '.txt'));

preg_match('/(|UE)BERSCHRIFT\s*\(\s*(.*?)\s*\)/is', $f, $m);
$ueberschrift = $m[2];

preg_match('/(EINLEITUNG|VORWORT)\s*\(\s*(.*?)\s*\)/is', $f, $m);
$einleitung = $m[2];
$einleitung = preg_replace('/(\s*?\n){2,}/', "</p>\n\n<p>", $einleitung);

if ($_POST['multiple_choize_erzwingen'] != '0')
{
  preg_match('/MULTIPLE_CHOIZE_ERZWINGEN\s*\(\s*(\[.*?\])?\s*(\w+)/is', $f, $m);
  if (strtolower($m[2]) == 'hinweis') $multiple_choize_erzwingen = 2;
  elseif (strtolower($m[2]) == 'ja') $multiple_choize_erzwingen = true;
}

preg_match('/NULL\s*\(\s*(\[.*?\])?(.*?)\)/is', $f, $m);
$null = trim($m[2]);

//----------------------------------------------------------------------------

$form = "<p>$einleitung</p>\n\n";
$form .= "<form name=\"formular\" action=\"$PHP_SELF\" method=post>\n";
$form .= "<table border=0 cellpadding=3 cellspacing=0 width=\"100%\">\n";
$form .= "<tr><td colspan=3><hr></td></tr>\n\n";

//----------------------------------------------------------------------------

preg_match_all('/FRAGE\s*\(\s*(.*?)\s*\)(.*?)(?=FRAGE\s*\(|$)/is', $f, $fragen, PREG_SET_ORDER);

foreach ($fragen as $nummer => $frage)
{
  $nummer++;
  $form .= "<tr><th>$nummer.</th>\n<td>$frage[1]</td>\n<td>";

  preg_match_all('/(CHECKBOX|AUSWAHLLISTE|RADIOBUTTONS|EINGABEFELD|EINGABEBEREICH|VERSTECKT)\s*\(\s*(.*?)\s*\)/is',
      $frage[2], $felder, PREG_SET_ORDER);

  foreach ($felder as $unternummer => $feld)
  {
    // Vor und zwischen versteckten Formularfeldern keine Trennlinie anzeigen.
    if ($unternummer && $feld[1] != "VERSTECKT" &&
        $felder[$unternummer - 1][1] != "VERSTECKT") $form .= "<hr>\n";

    $name = "v$nummer";
    if ($unternummer) $name .= chr(97 + $unternummer);

    if ($res_kopf) $res_kopf .= ',';
    $res_kopf .= $name;

    $anzeigename = "$nummer.";
    if ($unternummer) $anzeigename .= chr(97 + $unternummer) . ')';

    switch ($feld[1])
    {
      case 'CHECKBOX':
        if (preg_match('/\[(.*?)\]/s', $feld[2], $m))
        {
          $form .= "$m[1]<br>\n";
          $feld[2] = preg_replace('/\s*\[.*?\]\s*/s', '', $feld[2], 1);
        }
        preg_match('/((.*?)=>)?(.*)/s', $feld[2], $m);
        $eintrag_value = trim($m[2]);
        $eintrag = trim($m[3]);
        if ($eintrag_value == '') $eintrag_value = $eintrag;
        $form .= "<input id=\"$name\" name=\"$name\" type=\"checkbox\" value=\"" . htmlspecialchars($eintrag_value) . "\">";
        $form .= "<label for=\"$name\">$eintrag</label>";
        break;

      case 'AUSWAHLLISTE':
        if ($_POST['submit'] && $multiple_choize_erzwingen && $_POST[$name] == '')
        {
          $form = "Bitte whlen Sie auch eine Antwort auf Frage <b>$anzeigename</b>.";
          if ($multiple_choize_erzwingen > 1)
          {
            $form .= "<p><form action=\"$PHP_SELF\" method=post>";
            foreach ($_POST as $key => $value)
              $form .= "<input type=hidden value=\"" . htmlspecialchars($value) . "\" name=\"$key\">\n";
            $form .= "<input type=hidden value=\"0\" name=\"multiple_choize_erzwingen\">";
            $form .= "<input type=submit value=\"Trotzdem abschicken\" name=\"submit\">";
            $form .= "</form>";
          }
          ausgabe($form, -1);
        }

        if (preg_match('/\[(.*?)\]/s', $feld[2], $m))
        {
          $form .= "$m[1]<br>\n";
          $feld[2] = preg_replace('/\s*\[.*?\]\s*/s', '', $feld[2], 1);
        }
        $form .= "<select name=\"$name\">\n";
        $form .= "<option value=\"\">-</option>\n";
        $liste = explode(';', $feld[2]);
        foreach ($liste as $eintrag)
        {
          preg_match('/((.*?)=>)?(.*)/s', $eintrag, $m);
          $eintrag_value = trim($m[2]);
          $eintrag = trim($m[3]);
          if ($eintrag == '') continue;
          if ($eintrag_value == '') $eintrag_value = $eintrag;
          $form .= "<option value=\"" . htmlspecialchars($eintrag_value) . "\">$eintrag</option>\n";
        }
        $form .= "</select>\n";
        break;

      case 'RADIOBUTTONS':
        if ($_POST['submit'] && $multiple_choize_erzwingen && $_POST[$name] == '')
        {
          $form = "Bitte whlen Sie auch eine Antwort auf Frage <b>$anzeigename</b>.";
          if ($multiple_choize_erzwingen > 1)
          {
            $form .= "<form action=\"$PHP_SELF\" method=post>";
            foreach ($_POST as $key => $value)
              $form .= "<input type=hidden value=\"" . htmlspecialchars($value) . "\" name=\"$key\">\n";
            $form .= "<input type=hidden value=\"0\" name=\"multiple_choize_erzwingen\">";
            $form .= "<input type=submit value=\"Trotzdem abschicken\" name=\"submit\">";
            $form .= "</form>";
          }
          ausgabe($form, -1);
        }

        if (preg_match('/\[(.*?)\]/s', $feld[2], $m))
        {
          $form .= "$m[1]<br>\n";
          $feld[2] = preg_replace('/\s*\[.*?\]\s*/s', '', $feld[2], 1);
        }
        $liste = explode(';', trim($feld[2], ";"));
        $nebeneinander = strlen(preg_replace('/[^;]+=>/', '', $feld[2])) < 50;
        $leerzeilen = (strlen(preg_replace('/[^;]+=>/', '', $feld[2])) / count($liste)) > 50;
        foreach ($liste as $i => $eintrag)
        {
          preg_match('/((.*?)=>)?(.*)/s', $eintrag, $m);
          $eintrag_value = trim($m[2]);
          $eintrag = trim($m[3]);
          if ($eintrag == '') continue;
          if ($eintrag_value == '') $eintrag_value = $eintrag;
          // Radio-Buttons mit einer einzigen Antwort sind nicht bedienbar.
          if (count($liste) == 1)
          {
            $form .= "<input id=\"$name\" name=\"$name\" type=\"checkbox\" value=\"" . htmlspecialchars($eintrag_value) . "\">";
          }
          else
          {
            $form .= "<input id=\"$name$i\" name=\"$name\" type=\"radio\" value=\"" . htmlspecialchars($eintrag_value) . "\">";
          }
          $form .= "<label for=\"$name$i\">$eintrag</label>";
          $form .= $nebeneinander ? " &nbsp;\n" : "<br>\n";
          if ($leerzeilen && $liste[$i + 1]) $form .= "<br>\n";
        }
        break;

      case 'EINGABEFELD':
        preg_match('/\[(.*?)\]/s', $feld[2], $m);
        $einheit = $m[1];
        $size = 50;
        //if (stristr($einheit, 'Std')) $size = 3;
        //if (strstr($einheit, '%')) $size = 3;
        if ($einheit) $size = 3;
        $feld[2] = preg_replace('/\s*\[.*?\]\s*/s', '', $feld[2], 1);
        if ($feld[2]) $form .= "$feld[2]<br>\n";
        $form .= "<input type=text size=$size maxlength=255 name=\"$name\"> $einheit\n";
        break;

      case 'EINGABEBEREICH':
        if ($feld[2]) $form .= "$feld[2]<br>\n";
        $form .= "<textarea cols=50 rows=3 name=\"$name\" wrap=virtual></textarea>\n";
        break;

      case 'VERSTECKT':
        $feld[2] = preg_replace('/\s*\[.*?\]\s*/s', '', $feld[2], 1);
        $form .= "<input name=\"$name\" type=\"hidden\" value=\"$feld[2]\">";
        break;
    }

    $antwort = stripslashes($_POST[$name]);
    $antwort = strtr($antwort, ',;"\'\\', '     ');
    $antwort = preg_replace('/\s+/', ' ', trim($antwort));
    if ($antwort == '') $antwort = $null;

    if ($_POST['submit'] && strlen($antwort) > 1000)
      ausgabe("Bitte fassen Sie die Antwort auf Frage <b>$anzeigename</b> etwas krzer.", -1);

    if ($res != '') $res .= ',';
    $res .= $antwort;
  }

  $form .= "</td></tr>\n";
  $form .= "<tr><td colspan=3><hr></td></tr>\n\n";
}

//----------------------------------------------------------------------------

preg_match('/SCHLU(SS|)(WORT)?\s*\(\s*(.*?)\s*\)/is', $f, $m);
$schluss = $m[3];

$form .= "</table>\n\n";
$form .= "<p><b>$schluss</b></p>\n\n";
$form .= "<input type=hidden value=\"$fragebogen\" name=\"fragebogen\">\n";
$form .= "<input type=submit value=\"Abschicken\" name=\"submit\">\n";
$form .= "</form>\n\n";

//----------------------------------------------------------------------------

if ($_POST['submit'] && $res)
{
  $fp = @fopen($fragebogen . '.csv', 'a+b');
  if (! $fp)
    ausgabe("Es ist ein schwerwiegender Schreibschutzfehler aufgetreten.", -2);

  flock($fp, 2);
  fseek($fp, 0);
  fgets($fp, 100000);

  while ($alt = fgetcsv($fp, 100000))
  {
    if (getenv('REMOTE_ADDR') == $alt[count($alt) - 1] &&
        strtotime($alt[count($alt) - 2]) + 300 > time())
      ausgabe("Von dieser Adresse aus wurde vor kurzem bereits ein Fragebogen abgeschickt.", -2);

    if ($res == implode(',', array_slice($alt, 0, -2)))
      ausgabe("Es wurde bereits ein identisch ausgefllter Fragebogen abgeschickt.", -2);
  }
  $res .= ',' . date('Y-m-d H:i:s') . ',' . getenv('REMOTE_ADDR');

  if (ftell($fp) == 0) fputs($fp, $res_kopf . ",zeit,ip\r\n");
  fputs($fp, $res . "\r\n");
  fclose($fp);

//  setcookie('teilnahme', 'ja', time() + 86400 * 30);

  ausgabe($schluss, -2);
}
else
{
  ausgabe($form);
}

?>